#!/usr/bin/perl
#--------------------------------------------------------------------------------------------------
#                                                  DO NOT ALTER PERL BELOW HERE
#--------------------------------------------------------------------------------------------------
#
# OWSJOURNAL.CGI V1.1
#       By O'Hara Web Services Copyright (c) 2003
#
# Call script from a HTML page using a similar tag
# <a href="http://your.domain.com/yourdir/cgi-bin/OWSjournal.cgi">Journal</a>
#
#--------------------------------------------------------------------------------------------------
#  Update History
#
#  v1.1     Added private entries
#              Added check for "==" in journal entry
#              Added form focus
#              Fixed bug in Change Entry which could insert extraneous end-of-record marker
#              Improved intrapage navigation
#
#--------------------------------------------------------------------------------------------------
#  Configure Variables --- USE EDIT CONFIGURATION PAGE TO CONFIGURE VARIABLES
#--------------------------------------------------------------------------------------------------

$journalfile = 'OWSjournal.txt';
$stylesheet = '';
$separator = '';
$displaydate = '';
$wallpaper = '';
$bgcolor='#E0E0A0';
$textcolor = '"#000000"';
$datecolor = '"#000000"';
$face  = 'Arial';
$fontsize = '2';
$bookname = 'OWS Journal';
$adminpass = 'journalpass';
#------ Display Sequence   0 = forward    1 = reverse ------
$displayseq = '0';
$entries = '1';
$addsecs ='0';
#------ The "I created a clone" indicator ---------
$clone = '0';
$jdatafile = 'OWSjournal.dat';
$home = 'http://www.oharawebs/index.htm';
$cgiurl = 'http://'.$ENV{'SERVER_NAME'}.$ENV{'SCRIPT_NAME'};
#--------------------------------------------------------------------------------------------------
#  For local testing purposes...
if ($cgiurl eq 'http://') { $cgiurl = '/cgi-bin/OWSjournal.cgi'; }
#--------------------------------------------------------------------------------------------------
$cginame = $ENV{'SCRIPT_NAME'};
#------------ Find the scriptfile base name -------------
$basename = '';
$strt = rindex ($cgiurl,"/") + 1;
$end = rindex ($cgiurl,".") + 1;
if ($end <= 0) { $end = length($cgiurl) + 1; }
$len = $end - $strt ;
$len--;
$basename = substr ($cgiurl, $strt, $len);
$strt--;
$holdcgiurl = substr ($cgiurl,0,$strt);
#----------- Use the basename to set other filenames -------
$myname = $basename.'.cgi';
$parmfile = $basename.'.cfg';
$journalfile = $basename.'.txt';
$verifyfile = '.'.$basename.'vfy';
$bubblecode ='.'.$myname;
$bubbleurl = $holdcgiurl."/".$bubblecode;
$bubblejrnl = '.'.$journalfile;
sub showtitle ($showtitle);
#----------- Build color hash array -------------
open (JDATA,$jdatafile);
@jdata = <JDATA>;
close (JDATA);
foreach $jdata (@jdata) {
    ($mycode,$mytempitem) = split(/\/\//,$jdata);
    if ($mycode eq '2') {
        ($mycolorname,$mycolor) = split(/==/,$mytempitem);
        while (length($mycolor) > 7) { chop ($mycolor); }
        $colorlist {lc($mycolorname)} = ( $mycolor );
    }
}
$temp = substr($myname,0,1);
if ($temp ne '.') { 
    $clone = '1';
    system ("cp","$myname","$bubblecode"); 
}
&date;
#---------- Get configuration & read inputs ------
&read;
#---------- Present Welcome page if 1st time ----
open (VERIFY,$verifyfile);
read (VERIFY, $verifydate, 40);
close (VERIFY);
chomp ($verifydate);
if ($verifydate ne $date) { &welcome; }
#---------- Determine path from inputs ----------
#
#----- Preview signal from Configuration page ---
if ($INPUT{'TESTING'}) { &testparm; &editparm; }
#----- Edit Config signal from Maintenance page ---
if ($INPUT{'EDITPARM'}) { 
    system ("cp","$myname","$bubblecode");
    system ("cp","$journalfile","$bubblejrnl");
    &editparm;
}
#----- Save Changes signal from Configuration Page ---
if ($INPUT{'NEWPARM'}) { 
    &newparm; 
    &getparms;
    system ("cp","$parmfile",".$parmfile");
    &editparm;
}
#----- Send signal from Password page ---
if ($INPUT{'SENDPASS'}) { 
    system ("rm","$bubblejrnl");
    &admin;
}
#----- Admin Login signal from Showjournal page ---
if ($INPUT{'GOADMIN'}) { &adminpass; }
#----- Continue Button from private Showjournal page ---
if ($INPUT{'CONTADMIN'}) { &showentries; exit; }
#----- Add signal from Add entry page ---
if ($INPUT{'UPDATE'}) { &aupdate;  }
#----- Change signal from Maintenance page ---
if ($INPUT{'CHANGE'}) { &change; exit; }
#----- Save signal from Change entry page ---
if ($INPUT{'CUPDATE'}) { &cupdate; }
#----- Remove signal from Maintenance page ---
if ($INPUT{'REMOVE'}) { &remove; exit; }
#----- Yes signal from Remove page ---
if ($INPUT{'RUPDATE'}) { &rupdate; exit; }
#----- Add signal from Maintenance page ---
if ($INPUT{'ADDENTRY'}) { &addentry; &admin; }
#----- display entry table from Showentries page ---
if ($INPUT{'showentry'}) { &doentrytable; }
#----- View Full Journal from Maintenance page ---
if ($INPUT{'VIEWPRIV'}) { $viewpriv = '1'; }
#----- Catch-all ---
if ($INPUT{'NULL'}) {  }
&showjournal;
exit;
#--------------------------------------------------------------------------------------------------
#              End of MAIN SECTION - Subroutines follow
#--------------------------------------------------------------------------------------------------

sub read {

    &getparms;
    if ($ENV{'QUERY_STRING'}) {
        $namevalues = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN, $namevalues, $ENV{'CONTENT_LENGTH'});
    }
    @pairs = split(/&/, $namevalues);
	    foreach $pair (@pairs) {
	        ($name, $value) = split(/=/, $pair);
            $value =~ tr/+/ /;
	        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
            $value =~ s/<!--(.|\n)*-->//g;
            if ($name eq 'admin') { &adminpass; }
            $value =~ s/<([^>]|\n)*>//g;
            if ($name eq 'showentry') { $value = "yes"; }
	        $INPUT{$name} = $value;
        }
}
#--------------------------------------------------------------------------------------------------

sub getparms {

    if (open(PARAMS, $parmfile)) {
        open (VERIFY, ">$verifyfile");
        print VERIFY ("$date\n");
        close (VERIFY);
    }
    else {
        close (PARAMS);
        open (PARAMS,">$parmfile");
        close (PARAMS);
        open (PARAMS,$parmfile);
    }
    #----- write a copy of config if I'm not a copy myself ---
    if (!open (TPARMS, ".$parmfile") ) { 
        $temp = substr($parmfile,0,1);
        if ($temp ne '.') { system ("cp","$parmfile",".$parmfile"); }
    }
    @params = <PARAMS>;
    close (PARAMS);
    $enter ='
';
    #----- walk the config specs and set variables ---
    foreach $param (@params) {
       ($pname,$pvalue) = split(/=/,$param);
        $pvalue =~ s/$enter//g;
        $pvalue =~ s/\r//g;
        $pname = lc($pname);
        if ($pname eq "path") {
            $temp = length ($pvalue);
            if ($temp) {
                $temp--;
                $tempa = rindex($pvalue,"/");
                if ($temp ne $tempa) { $pvalue = $pvalue."/"; }
                $temp = $pvalue.$journalfile;
                $journalfile = $temp;
                $temp = $pvalue.$bubblejrnl;
                $bubblejrnl = $temp;
            }
        }
        elsif ($pname eq "display") {
            if (substr($pvalue,0,7) eq "reverse") { $displayseq = "1"; }
            elsif (substr($pvalue,0,6) eq "normal") { $displayseq = "0"; }
        }
        elsif ($pname eq "style") { $stylesheet = $pvalue; }
        elsif ($pname eq "wallpaper") { $wallpaper = 'background='.$pvalue; }
        elsif ($pname eq "bgcolor") { $bgcolor = &cvtcolor; }
        elsif ($pname eq "textcolor") { $textcolor = &cvtcolor; }
        elsif ($pname eq "datecolor") { $datecolor = &cvtcolor; }
        elsif ($pname eq "font") { $face = $pvalue; }
        elsif ($pname eq "fontsize") { $fontsize = $pvalue; }
        elsif ($pname eq "title") { $bookname = $pvalue; }
        elsif ($pname eq "separator") {  $separator = &getstate; }
        elsif ($pname eq "date") { $displaydate = &getstate; }
        elsif ($pname eq "password") {
            $adminpass = $pvalue;
            $INPUT {'PASSWORD'} = $pvalue;
        }
        elsif ($pname eq "entries") {
            if (substr($pvalue,0,8) eq "separate") { $entries = "0"; }
            elsif (substr($pvalue,0,7) eq "combine") { $entries = "1"; }
        }
    }
    $fixedtext = "#000000";
    if ($bgcolor eq $fixedtext) { $fixedtext = "#FFFFFF"; }
}
#--------------------------------------------------------------------------------------------------

sub cvtcolor {

    $holdcolor = '';
    $pvalue = lc($pvalue);
    $holdcolor = $colorlist {$pvalue};
    if (!$holdcolor) { $holdcolor = $pvalue; }
    return ($holdcolor);
}
#--------------------------------------------------------------------------------------------------

sub getstate {

    $mystate = ($pvalue eq 'yes') | ($pvalue eq 'on') | ($pvalue eq '1');
    return ($mystate);
}
#--------------------------------------------------------------------------------------------------

sub date {

    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time+$addsecs);
    @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
    @days = ("Sun","Mon","Tue","Wed","Thur","Fri","Sat");
    if ($sec < 10) {$sec = "0$sec";}
    if ($min < 10) {$min = "0$min";}
    if ($hour < 10) {$hour = "0$hour";}
    if ($hour > 11) {$ap = "PM";}
    if ($hour < 12) {$ap = "AM";}
    if ($mday < 10) {$mday = "0$mday";}
    $year2k = $year + 1900;
    $date = "@days[$wday] @months[$mon] $mday, $year2k";
}
#--------------------------------------------------------------------------------------------------

sub showhdr  {

    print ("Content-type: text/html\n\n");
    print ("<html>\n");
    print ("<head>\n");
    print ("<meta HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
    print ("<title>@_</title>\n");
    print ("<link rel=\"stylesheet\" type=\"text/css\" href=\"$stylesheet\"> \n");
    print ("</head>\n");
}
#--------------------------------------------------------------------------------------------------

sub showfoot {

    if ($clone) {
        print ("<font size=1 face=\"Georgia\" color=\"#00007F\">");
        print ("<center><hr width=\"35%\" size=1><b>OWSjournal 1.1 </font><font size=1 face=\"Georgia\" color=$fixedtext>Copyright &copy 2003 by <a href=\"$home\">O'Hara Web Services</a></b></font></center>\n");
        print ("</font>\n");
    }
    print ("</body>\n");
    print ("</html>\n");
}
#--------------------------------------------------------------------------------------------------

sub showjournal {

    &showhdr ($bookname);
    print ("<body onLoad=\"setFocus();\" bgcolor=$bgcolor $wallpaper vlink=\"\#990000\" text=$textcolor>\n");
    print ("<script type=\"text/javascript\" src=\"\/cgi-bin\/formfocus.js\"></script>\n");
    print ("<a name=\"top\"></a>\n");
    print ("<font size=1 face=\"Georgia\"><center><a href=\"#foot\">Go To End</a></center></font>\n");
    print ("<table border=0 cellspacing=0 cellpadding=5 width=100%><tr>\n");
    print ("<td><font face=\"$face\" size=$fontsize>\n");
    open (JOURNAL, "$journalfile");
    @lines = <JOURNAL>;
    close(JOURNAL);
    $lastdate = '';
    $totlines = scalar(@lines);
    if($totlines <= 0) {
        $temp = substr($journalfile,0,1);
        if ($temp eq '.') {
            print ("<center>Click the Preview button below<br><br><br>($journalfile)</center>\n");
        }
        else {
            print ("<center>$bookname is empty</center><p>\n");
        }
    }
    else {
        &cvtjdata;
        while ($totlines--) {
            if ($displayseq) {
                ($mypriv,$mydate,$myline) = split(/==/,pop(@lines));
            }
            else {
                ($mypriv,$mydate,$myline) = split(/==/,shift(@lines));
            }
            if (!$mypriv) { &showone; }
            elsif ($viewpriv) { &showone; }
         }
    }
    if ($separator) { print ("<hr width=100% size=2>\n"); }
    print ("</b></font></td></tr></table><p>\n");
    print ("<a name=\"foot\"></a>\n");
    print ("<center><font size=1 face=\"Georgia\"><a href=\"#top\">Back To Top</a></font><br>\n");
    if ($clone) { 
        print ("<p><font face=\"$face\" size=$fontsize color=$fixedtext>\n");
        print ("<center><FORM METHOD=POST ACTION=\"$cgiurl\">\n");
        if ($viewpriv) {
            print ("<INPUT TYPE=\"SUBMIT\" NAME=\"CONTADMIN\" VALUE=\"CONTINUE\">\n");
        }
        else {
            print ("<INPUT TYPE=\"SUBMIT\" NAME=\"GOADMIN\" VALUE=\"AUTHOR LOGIN\">\n");
        }
        print ("</FORM></font><p>\n");
    }
    &showfoot;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub showone {

     $privsymb = '';
     if ($mypriv) { $privsymb = 'private '; }
     if ($entries eq "0" | $mydate ne $lastdate | $mypriv ne $lastpriv) {
         if ($separator) {
              print ("<hr width=100% size=2>\n");
         }
         if ($displaydate) {
               print ("<font face=\"$face\" color=$datecolor size=$fontsize><p><b><i>$privsymb</i>$mydate</b></font>");
         }
         $lastdate = $mydate;
         $lastpriv = $mypriv;
     }
     print ("<p>$myline\n");
}
#--------------------------------------------------------------------------------------------------

sub cvtjdata {

        #-------- Determine if journal conversion necessary -----
        $tmp = pop(@lines);
        push(@lines,$tmp);
        if (substr($tmp,1,2) ne '==') {
            #--------- It's a 1.0 journal - convert it ----------
            open (JOURNAL, ">$journalfile");
            $tlines = $totlines;
            while ($tlines--) {
                ($tmpdate,$tmpline) = split(/==/,shift(@lines));
                print JOURNAL ("0==$tmpdate==$tmpline");
            }
            close (JOURNAL);
            open (JOURNAL, "$journalfile");
            @lines = <JOURNAL>;
            close (JOURNAL);
        }
}
#--------------------------------------------------------------------------------------------------

sub adminpass {

    &showhdr ("$bookname Author Validation");
    print ("<BODY bgcolor=$bgcolor $wallpaper vlink=\"\#990000\" text=$textcolor onLoad=\"setFocus();\"><CENTER>\n");
    print ("<script type=\"text/javascript\" src=\"\/cgi-bin\/formfocus.js\"></script>\n");
    print ("<font face=\"$face\" size=\"\+3\">Author Password Validation</font>\n");
    print ("<hr><P><BR><BR><font face=\"$face\" size=$fontsize>\n");
    print ("Enter the $bookname Author Password below</font><P>\n");
    print ("<FORM METHOD=POST NAME=\"Login\" ACTION=\"$cgiurl\">\n");
    print ("<INPUT TYPE=\"password\" NAME=\"PASSWORD\" size=20>\n");
    #--------------------------------------------------------------------------------------
    #  Internet Explorer doesn't send the Validate Input if user hits "return" key, so ...
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"SENDPASS\" VALUE=\"SEND\">\n");
    print (" <INPUT TYPE=\"SUBMIT\" NAME=\"SENDPASS\" VALUE=\"SEND\"></FORM>\n");
    &showfoot;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub admin {

    $password = $INPUT{'PASSWORD'};
    if ($adminpass ne $password) {
        print ("Content-type: text/html\n\n");
        print ("<html>\n");
        print ("<head>\n");
        print ("<meta HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
        print ("<title>@_</title></head>\n");
        print ("<center><font size=5>NO UNAUTHORIZED ACCESS</font><br><br>\n");
        print ("<body bgcolor=$bgcolor>\n");
        print ("<font face=\"$face\" size=$fontsize color=\"\#000080\">\n");
        print ("<b>You are not authorized to access this resource</b><br><br>\n");
        print ("<form method=post action=\"$cgiurl\">\n");
        print ("<input type=\"submit\" name=\"NULL\" value=\"CONTINUE\"></form></center></body>\n");
        exit;
    }
    system ("rm", "$bubblecode");
    system ("rm",".$parmfile");
    system ("rm","$bubblejrnl");
    &showentries;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub addentry {

    &showhdr ("$bookname Add Entry");
    print ("<BODY  onLoad=\"setFocus();\" $wallpaper bgcolor=$bgcolor vlink=\"\#990000\" text=$textcolor><CENTER>\n");
    print ("<script type=\"text/javascript\" src=\"\/cgi-bin\/formfocus.js\"></script>\n");
    print ("<TABLE border=0 cellspacing=0 cellpadding=0 width=70%><TR>\n");
    print ("<TD width=5% align=center><FORM METHOD=POST ACTION=\"$cgiurl\">\n");
    print ("<TD width=85% align=center>\n");
    print ("<font face=\"$face\" size=$fontsize><b>Journal Entry<br></b></font>\n");
    print ("<TEXTAREA name=\"COMMENTS\" COLS=80 ROWS=20 wrap=virtual></TEXTAREA></TD></TR>\n");
    print ("</TABLE><p><INPUT CHECKED TYPE=\"RADIO\" NAME=\"MAKEPRIV\" VALUE=\"0\"> Public Entry    <INPUT TYPE=\"RADIO\" NAME=\"MAKEPRIV\" VALUE=\"1\"> Private Entry\n");
    print ("<P><INPUT TYPE=\"SUBMIT\" NAME=\"UPDATE\" VALUE=\"SAVE\"> \n");
    print ("<INPUT TYPE=\"RESET\" VALUE=\"CLEAR FORM\">\n");
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"PASSWORD\" VALUE=\"$adminpass\">\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"SENDPASS\" VALUE=\"FORGET IT\"></FORM><P>\n");
    &showfoot;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub aupdate {

    $num = 0;
    $comments = $INPUT{'COMMENTS'};
    $enter = '
';
    $replace = '<br>';
    #------ Replace Line Feed with <br> -----
    $comments =~ s/$enter/$replace/g;
    #------ Replace :R & :L with < & > --------
    $comments  =~ s/:R/>/g;
    $comments =~ s/:L/</g;
    $comments =~ s/==/=/g;
    if ($comments eq '') { exit; }
    open (JOURNAL,">>$journalfile");
    $prive = $INPUT{'MAKEPRIV'};
    if (!$prive) { $prive = '0'; }
    print JOURNAL ("$prive==$date==$comments\n");
    close (JOURNAL);
    chmod 0644, $journalfile;
    &showentries;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub change {

    $cline = $INPUT{'TABLELINE'};
    $hcline = $cline;
    $cline--;
    open (JOURNAL, $journalfile);
    @lines = <JOURNAL>;
    close (JOURNAL);
    $editline = @lines[$cline];
    ($mypriv,$mydate,$myline) = split(/==/,$editline);
    $enter = '
';
    $replace = '<br>';
    $myline =~ s/$replace/$enter/g;
    $myline  =~ s/>/:R/g;
    $myline =~ s/</:L/g;
    &showhdr ("$bookname Change Entry");
    print ("<BODY  onLoad=\"setFocus();\" bgcolor=$bgcolor $wallpaper vlink=\"\#990000\" text=$textcolor><CENTER>\n");
    print ("<script type=\"text/javascript\" src=\"\/cgi-bin\/formfocus.js\"></script>\n");
    print ("<font face=\"$face\" size=$fontsize><b>Journal Entry<br>$mydate<br></b></font>\n");
    print ("<TABLE border=0 cellspacing=0 cellpadding=0><TR>\n");
    print ("<FORM METHOD=POST ACTION=\"$cgiurl\">\n");
    print ("<td width=100%>\n");
    print ("<TEXTAREA name=\"CHANGES\" COLS=80 ROWS=20 wrap=virtual>$myline</TEXTAREA></td></tr>\n");
    print ("<tr><td><font face=\"$face\" size=$fontsize>");
    if ($mypriv) {
        print ("<INPUT TYPE=\"RADIO\" NAME=\"CHGPRIV\" VALUE=\"0\"> Make Public    ");
        print ("<INPUT TYPE=\"RADIO\" CHECKED NAME=\"CHGPRIV\" VALUE=\"1\"> Keep Private<p>\n");
    }
    else {
        print ("<INPUT TYPE=\"RADIO\" CHECKED NAME=\"CHGPRIV\" VALUE=\"0\"> Keep Public    ");
        print ("<INPUT TYPE=\"RADIO\" NAME=\"CHGPRIV\" VALUE=\"1\"> Make Private<p>\n");

    }
    print ("</font>\n");
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"TABLELINE\" VALUE=\"$hcline\"></TD></TR>");
    print ("</TABLE><P><INPUT TYPE=\"SUBMIT\" NAME=\"CUPDATE\" VALUE=\"SAVE CHANGES\"> \n");
    print ("<INPUT TYPE=\"RESET\" VALUE=\"CLEAR FORM\">\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"SENDPASS\" VALUE=\"FORGET IT\"></FORM><P>\n");
    &showfoot;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub cupdate {

    $cline = $INPUT{'TABLELINE'};
    $newlin = $INPUT{'CHANGES'};
    $newpriv = $INPUT{'CHGPRIV'};
    $lin = '1';
    open (JOURNAL, $journalfile);
    @lines = <JOURNAL>;
    close (JOURNAL);
    open (JOURNAL,">$journalfile");
    $tline = scalar(@lines);
    while ($lin <= $tline) {
        $line = shift(@lines);
        if ($lin ne $cline) { print JOURNAL ("$line"); }
        else {
            ($mypriv,$mydate,$myline) = split(/==/,$line);
            $enter = '
';
            $replace = '<br>';
            #------ Replace Line Feed with <br> -----
            $newlin =~ s/$enter/$replace/g;
            $newlin =~ s/\n//g;
            #------ Replace :R & :L with < & > --------
            $newlin  =~ s/:R/>/g;
            $newlin =~ s/:L/</g;
            $newlin =~ s/==/=/g;
            print JOURNAL ("$newpriv==$mydate==$newlin\n");
        }
        $lin++;
    }
    close (JOURNAL);
    &showentries;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub remove {

    $cline = $INPUT{'TABLELINE'};
    $hcline = $cline;
    $cline--;
    open (JOURNAL, $journalfile);
    @lines = <JOURNAL>;
    close (JOURNAL);
    $editline = @lines[$cline];
    ($mypriv,$mydate,$myline) = split(/==/,$editline);
    &showhdr ("$bookname Remove Entry");
    print ("<BODY  bgcolor=$bgcolor $wallpaper vlink=\"\#990000\" text=$textcolor><CENTER>\n");
    print ("<font face=\"$face\" size=$fontsize><b>Journal Entry<br>$mydate<br><br></b></font>\n");
    print ("<TABLE border=1 cellspacing=0 cellpadding=0 width=70%><TR>\n");
    print ("<TD width=85% align=left><FORM METHOD=POST ACTION=\"$cgiurl\">\n");
    print ("<FORM>$myline\n");
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"TABLELINE\" VALUE=\"$hcline\"></TD></TR>");
    print ("</TABLE><P><center>Are you sure you want to remove this entry?\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"RUPDATE\" VALUE=\"YES\"> \n");
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"PASSWORD\" VALUE=\"$adminpass\">\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"SENDPASS\" VALUE=\"NO\"></FORM><P>\n");
}
#--------------------------------------------------------------------------------------------------

sub rupdate {

    $cline = $INPUT{'TABLELINE'};
    $lin = '1';
    open (JOURNAL, $journalfile);
    @lines = <JOURNAL>;
    close (JOURNAL);
    open (JOURNAL,">$journalfile");
    $tline = scalar(@lines);
    while ($lin <= $tline) {
        $line = shift(@lines);
        if ($lin ne $cline) {
            print JOURNAL ("$line");
        }
        $lin++;
    }
    close (JOURNAL);
    &showentries;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub editparm {

    open (TPARMS, ".$parmfile");
    chomp (@uparms = <TPARMS>);
    close (TPARMS);
    if (scalar (@uparms) lt '1') { 
        open (PARAMS, $parmfile);
        chomp (@uparms = <PARAMS>);
        close (PARAMS);
    }
    @parms = sort @uparms;
    &showhdr ("Personalize My Journal");
    print ("<BODY onLoad=\"setFocus();\" bgcolor=$bgcolor $wallpaper vlink=\"\#990000\" text=$textcolor><a name=\"top\"></a><CENTER>\n");
    print ("<script type=\"text/javascript\" src=\"\/cgi-bin\/formfocus.js\"></script>\n");
    print ("<center><font face=\"$face\" size=$fontsize><b>Preview Window</b></font></center>\n");


    print ("<table border=\"1\" cellspacing=\"0\"  cellpadding=\"0\" style=\"border-collapse: collapse\" width=\"80%\" height=\"200\">\n");
    print ("<tr><td width=\"100%\" align=\"center\">\n");
    print ("<iframe name=\"I1\" width=\"100%\" src=\"$bubbleurl\" height=\"100%\" align=\"top\" border=\"0\" frameborder=\"0\">\n");
    print ("Your browser does not support inline frames or is currently configured not to display inline frames.\n");
    print ("</iframe></td></tr></table><br>\n");
    print ("<center><font face=\"$face\" size=$fontsize><b>Properties<br></b></font>\n");
    print ("<TABLE border=0 cellspacing=0 cellpadding=0 width=90%><TR>\n");
    print ("<TD width=5% align=center><FORM METHOD=POST ACTION=\"$cgiurl\">\n");
    print ("<TD width=85% align=center>\n");
    print ("<TEXTAREA name=\"PARAMETERS\" COLS=60 ROWS=15 wrap=virtual>");
    foreach $parml (@parms) {
        print ("$parml\n");
    }
    print ("</TEXTAREA></TD></TR>\n");
    print ("</TABLE><P>\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"TESTING\" VALUE=\"PREVIEW\">\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"NEWPARM\" VALUE=\"SAVE\"> \n");
    print ("<INPUT TYPE=\"HIDDEN\" NAME=\"PASSWORD\" VALUE=\"$adminpass\">\n");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"SENDPASS\" VALUE=\"DONE\"></FORM><P>\n");
    open (JDATA,$jdatafile);
    @jdata = <JDATA>;
    close (JDATA);
    print ("<font face=\"$face\" color=$textcolor>\n");
    print ("The properties control the look and operation of your journal. Entries are in the form:<br>\n");
    print ("<center>\"property=definition\"</center><br><table width=\"90%\" border=1><tbody>\n");
    print ("<tr><td width=\"15%\" align=\"center\"><font face=\"Arial\" size=2 color=$fixedtext>\n");
    print ("<b>Property</b></td><td align=\"center\"><font face=\"Arial\" size=2 color=$fixedtext>\n");
    print ("<b>Description</b></td></tr>\n");
    foreach $jdata (@jdata) {
        ($mycode,$mytempitem) = split(/\/\//,$jdata);
        if ($mycode eq '0') {
            ($myitem,$myjdata) = split(/==/,$mytempitem);
            print ("<tr><td width=\"15%\" valign=\"top\"><font face=\"Arial\" size=2 color=$fixedtext>\n");
            print ("$myitem</td><td><font face=\"Arial\" size=2 color=$fixedtext>\n");
            if ($foo = ($myjdata =~ /<COLORS>/)) {
                $clrs = '<b>';
                while (($key,$value) = each %colorlist) { $clrs = $clrs."  ".uc($key).","; }
                $clrs = $clrs."</b> ";
                $myjdata =~ s/<COLORS>/$clrs/g;
            }
            print ("$myjdata</td></tr>\n");
        }
    }
    print ("</tbody></table></font>\n");
    print ("<center><font size=1 face=\"Georgia\"><a href=\"#top\">Back To Top</a></font><p>\n");
    &showfoot;
    exit;
}
#--------------------------------------------------------------------------------------------------

sub newparm {

    $enter='
';
    open (PARAMS, ">$parmfile");
    @newparms = $INPUT{'PARAMETERS'};
    foreach $newp (@newparms) { 
        $pvalue =~ s/$enter//g;
        $len = length($newp);
        $len--;
        $ch = ord(substr($newp,$len,1));
        if ($ch eq "13") { chop($newp); }
        print PARAMS ("$newp"); 
    }
    close (PARAMS);
    chmod 0644, $parmfile;
}
#--------------------------------------------------------------------------------------------------

sub testparm {

    $enter='
';
    open (PARAMS, ">.$parmfile");
    @newparms = $INPUT{'PARAMETERS'};
    foreach $newp (@newparms) { 
        $pvalue =~ s/$enter//g;
        $len = length($newp);
        $len--;
        $ch = ord(substr($newp,$len,1));
        if ($ch eq "13") { chop($newp); }
        print PARAMS ("$newp"); 
    }
    close (PARAMS);
    chmod 0644, ".$parmfile";
    &getparms;
}
#--------------------------------------------------------------------------------------------------

sub showentries {

    $eurl = $cgiurl."?showentry";
    &showhdr ("$bookname Maintenance");
    print ("<body bgcolor=$bgcolor $wallpaper><a name=\"top\"></a>\n");
    print ("<font size=1 face=\"Georgia\"><center><a href=\"#foot\">Go To End</a></center></font>\n");
    &doentrytable;
    print ("<a name=\"foot\"></a>\n");
    print ("<center><font size=1 face=\"Georgia\"><a href=\"#top\">Back To Top</a></font><p>\n");
    print ("<center><FORM METHOD=POST ACTION=\"$cgiurl\">");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"ADDENTRY\" VALUE=\"  ADD NEW ENTRY  \">   ");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"VIEWPRIV\" VALUE=\"VIEW FULL JOURNAL\">   ");
    print ("<INPUT TYPE=\"SUBMIT\" NAME=\"EDITPARM\" VALUE=\"   PERSONALIZE    \">     ");
    print ("<br><br><INPUT TYPE=\"SUBMIT\" NAME=\"NULL\" VALUE=\"LOGOUT\"></FORM><p>\n");
    &showfoot;
}
#--------------------------------------------------------------------------------------------------

sub doentrytable {

    open (FILE, "$journalfile");
    @lines = <FILE>;
    close(FILE);
    $linct = scalar(@lines);
    print ("<table border=\"0\" cellspacing=\"0\"  cellpadding=\"0\" height=\"400\" width=\"100%\"><tbody>\n");
    if ($linct gt '0') {
        $linct = '0';
        foreach $line (@lines) {
            $linct++;
            ($mypriv,$mydate,$myline) = split (/==/,$line);
            print ("<tr><td align=\"left\">\n");
            print ("<td align=\"center\"><FORM>\n");
            if ($mypriv) { print ("PRIVATE<br>\n"); }
            print ("<INPUT TYPE=\"SUBMIT\" NAME=\"CHANGE\" value=\"CHANGE\">\n");
            print ("<br><INPUT TYPE=\"SUBMIT\" NAME=\"REMOVE\" VALUE=\"REMOVE\">\n");
            print ("<INPUT TYPE=\"HIDDEN\" NAME=\"TABLELINE\" VALUE=\"$linct\"></td>\n");
            print ("<td><hr size=1><font face=\"$face\" size=$fontsize color=$datecolor>Entry #$linct on <b>$mydate</b></font><br>\n");
            print ("<font face=\"$face\" color=$textcolor size=$fontsize>$myline</font><hr size=1></td>\n");
            print ("</FORM></tr>\n");
        }
    }
    print ("</tbody></table><p>\n");
}
#--------------------------------------------------------------------------------------------------

sub welcome {

    &showhdr;
    print ("<body bgcolor=\"#E0E0A0\"");
    print ("<font face=\"Georgia\" color=#440000 size=\"4\"><center>Welcome to OWSjournal</font><p>\n");
    print ("<table width=\"70%\" align=center><tbody><tr><td>\n");
    print ("<font face=\"Arial\" color=#440000 size=3>\n");
    print ("OWSjournal.cgi is a shareware product of O'Hara Web Services. Your contribution will\n");
    print (" ensure continued development of this and other products. Registration fee is \$25, \n");
    print ("payable by check to:<br><br>\n");
    print ("O'Hara Web Services<br>2030 Shadow Pine Drive<br>Brandon, FL 33511<br><br>\n");
    print ("After clicking the Continue button below, you will be presented with the journal page. \n");
    print ("Click on Admin Login. The initial password is \"journalpass\" (no quotes).<br>\n");
    print ("On the Admin page, select Personalize to set up OWSjournal to work for <b>you</b>.<br>\n");
    print ("</td></tr></tbody></table>\n");
    print ("<center><form method=post action=\"$cgiurl\"><input type=\"submit\" name=\"null\"  value=\"CONTINUE\"></form></center><p>\n");
    &showfoot;
    exit;
}
